use {Message, Channel, User};

#[derive(Debug)]
pub enum Event {
    Message { message: Message },     // A user sends a message

    SelfJoin { channel: Channel },    // We join a channel
    SelfQuit { channel: Channel },    // We quit a channel

    UserJoin { channel: Channel, user: User }, // A user joins a channel
    UserQuit { channel: Channel, user: User }  // A user quits a channel
}

#[derive(Debug)]
pub struct Envelope {
    pub from: String,
    pub event: Event,
}

impl Envelope {}
