use modules::EventLoop;
use toml::value::Table;

use std::sync::Arc;
use std::sync::mpsc::Receiver;
use transformable_channels::mpsc::ExtSender;

use event::{Event, Envelope};

pub struct LoggerModule {}

impl LoggerModule {
    pub fn new (_: &Table, configuration: &Table) -> Box<EventLoop> {
        Box::new(LoggerModule {})
    }
}

impl EventLoop for LoggerModule {
    fn run(&self, _: Box<ExtSender<Event>>, receiver: Receiver<Arc<Envelope>>) {
        loop {
            match receiver.recv() {
                Ok(envelope) => {
                    info!("Received event envelope: {:?}", envelope);
                }
                Err(error) => { error!("Error {:?}", error) }
            }
        }
    }
}
